$Id: New.feature,v 1.4 2004/07/07 14:50:54 purna Exp $

New features in LIDS 1.2.X:
===========================

1. ACL DISCOVERY MODE and Stateful ACL 
	Check the FAQ in the lidstools-0.5.x/doc/ directory.

2. Stateful ACLs 
	LIDS acl states are divided into 4 types:
		GLOBAL/BOOT/POSTBOOT/SHUTDOWN.
	Just like ipchains/iptable name, now, when you define an ACL,
	you need to define the type for it,  

	# lidsconf -A POSTBOOT -s /usr/sbin/sshd -o /etc/shadow -j READONLY
		--> This enables sshd to read /etc/shadow after "lidsadm -I"

	# lidsconf -A BOOT -o /var -j READONLY
	# lidsconf -A BOOT -s /usr/bin/httpd -o /var/log/message -j WRITE
		--> This enables httpd to read/write /var/log/message
		during booting. (before "lidsadm -I") 

	If you do not provide an acl type, it belongs to GLOBAL which will
	apply to all states.

	# lidsconf -A -o /boot -j READONLY
	# lidsconf -A -o /etc/lids -j READONLY

3. EXEC restriction to process

	# lidsconf -A -s /usr/sbin/smbd -o LIDS_EXEC -j ENABLE

	With this ACL, smbd can not execute any program other than
	itself "/usr/sbin/smbd"

	This feature helps disable some buffer overflows
	finally trying to execute "/bin/sh" or some other programs.  
		
4. Process Network Access Restriction (PNAR)

	# lidsconf -A POSTBOOT -s /usr/sbin/sshd -o LIDS_SOCKET_BIND -j DISABLE
	
	This restricts any process under sshd not to bind any port.

5. LIDS Trusted Path Execution (TPE)

	# lidsadm -S -- +TPE

	This turns on LIDS TPE mode. In TPE mode, LIDS will only execute
	binaries as well as libraries, and load kernel modules as far as
	they are protected with READONLY at the minimum. 

	LIDS-TPE-feature.txt gives some details on this feature.

6. LIDS Trusted Domain Enforcement (TDE)

	[*] Enable LIDS Trusted Domain Enforcement (TDE) feature

	or

	CONFIG_LIDS_TDE=y

        If TDE was enabled in the kernel, LIDS will enforce a TDE policy
        during its operation: A privileged process that reads unprotected input,
        including character devices, files, etc, will be moved into the
        untrusted domain.

        A process moved into the untrusted domain still runs, but loses its
        privileges, including granted capabilities, set in LIDS ACLs.
        This will help reduce security risks to a certain extent in case
        the process is abused with malicious input.

        Granting CAP_PROTECTED to a process will force LIDS not to move the
        process into the untrusted domain even if the process reads unprotected
        input. In some cases, you need to grant CAP_PROTECTED to special
        processes that really need input from the standard input to make them
        run properly. The '/bin/su' program is an example. But care must
        be taken when granting CAP_PROTECTED to a process. Granting this
        capability to a not-so-well written script/binary increases the risks of
        the privileges/capabilities being abused by malicious input.

	TDE also enables an application sandboxing feature in LIDS.
	Once you put an application (say, /opt/myls) into a sandbox as follows:

        # lidsconf -A -s /opt/myls -o LIDS_SANDBOX -j ENABLE

	All rules for '/opt/myls' in order to run properly must be explicitly
	set. Thus, the basic principle for a sandboxed application is
	not "Default first, specific follows" but "All must be specified".
	The more specific the rules are, the tighter the sandbox is. 

	A more detailed explanation can be found in LIDS-TDE-feature.txt.

For more information, check the doc directory in the lidstools.


LIDS TEAM

July 2004
